"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _sequelize = _interopRequireDefault(require("sequelize"));

var _logger = require("./logger");

var _conn = require("./conn");

var _default = (config, hooksContext) => {
  (0, _logger.logInfo)('[postgres] init');
  const name = config.connectionName || 'default';
  const handler = new _sequelize.default(config.database, config.username, config.password, Object.assign({
    dialect: 'postgres',
    host: config.host,
    port: config.port,
    logging: config.logging || _logger.logDebug
  }, config.pool ? {
    pool: config.pool
  } : {}));
  (0, _conn.addHandler)(name, {
    name,
    config,
    handler,
    hooksContext
  });
};

exports.default = _default;